# -*- coding: utf-8 -*-

"""
lob

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from lob.api_helper import APIHelper
from lob.configuration import Server
from lob.controllers.base_controller import BaseController
from lob.utilities.union_type_lookup import UnionTypeLookUp
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from lob.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from lob.exceptions.domains_0_error_1_exception import Domains0Error1Exception


class IdentityValidationController(BaseController):

    """A Controller to access Endpoints in the lob API."""
    def __init__(self, config):
        super(IdentityValidationController, self).__init__(config)

    def identity_validation(self,
                            body):
        """Does a POST request to /identity_validation.

        Validates whether a given name is associated with an address.

        Args:
            body (object): TODO: type description here.

        Returns:
            RecipientValidation | CompanyValidation: Response from the API.
                Returns the likelihood a given name is associated with an
                address.

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/identity_validation')
            .http_method(HttpMethodEnum.POST)
            .header_param(Parameter()
                          .key('Content-Type')
                          .value('application/json'))
            .body_param(Parameter()
                        .value(body))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .body_serializer(APIHelper.json_serialize)
            .auth(Single('basicAuth'))
        ).response(
            ResponseHandler()
            .deserializer(lambda value: APIHelper.deserialize_union_type(
                 UnionTypeLookUp.get('identity_validation'), value))
            .local_error('default', 'Error', Domains0Error1Exception)
        ).execute()
