# -*- coding: utf-8 -*-

"""
lob

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from lob.api_helper import APIHelper


class AddressEditableIntl(object):

    """Implementation of the 'address_editable_intl' model.

    TODO: type model description here.

    Attributes:
        address_line_1 (str): The primary number, street name, and directional
            information.
        address_line_2 (str): An optional field containing any information
            which can't fit into line 1.
        address_city (str): TODO: type description here.
        address_state (str): TODO: type description here.
        address_zip (str): Optional postal code.
        description (str): An internal description that identifies this
            resource. Must be no longer than 255 characters.
        name (str): Either `name` or `company` is required, you may also add
            both. Must be no longer than 40 characters. If both `name` and
            `company` are provided, they will be printed on two separate lines
            above the rest of the address.
        company (str): Either `name` or `company` is required, you may also
            add both. Must be no longer than 40 characters. If both `name` and
            `company` are provided, they will be printed on two separate lines
            above the rest of the address. This field can be used for any
            secondary recipient information which is not part of the actual
            mailing address (Company Name, Department, Attention Line, etc).
        phone (str): Must be no longer than 40 characters.
        email (str): Must be no longer than 100 characters.
        address_country (CountryExtendedEnum): TODO: type description here.
        metadata (Dict[str, str]): Use metadata to store custom information
            for tagging and labeling back to your internal systems. Must be an
            object with up to 20 key-value pairs. Keys must be at most 40
            characters and values must be at most 500 characters. Neither can
            contain the characters `"` and `\`. i.e. '{"customer_id" :
            "NEWYORK2015"}' Nested objects are not supported.  See
            [Metadata](#section/Metadata) for more information.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "address_line_1": 'address_line1',
        "name": 'name',
        "company": 'company',
        "address_country": 'address_country',
        "address_line_2": 'address_line2',
        "address_city": 'address_city',
        "address_state": 'address_state',
        "address_zip": 'address_zip',
        "description": 'description',
        "phone": 'phone',
        "email": 'email',
        "metadata": 'metadata'
    }

    _optionals = [
        'address_line_2',
        'address_city',
        'address_state',
        'address_zip',
        'description',
        'phone',
        'email',
        'metadata',
    ]

    _nullables = [
        'address_line_2',
        'address_city',
        'address_state',
        'address_zip',
        'description',
        'name',
        'company',
        'phone',
        'email',
    ]

    def __init__(self,
                 address_line_1=None,
                 name=None,
                 company=None,
                 address_country=None,
                 address_line_2=APIHelper.SKIP,
                 address_city=APIHelper.SKIP,
                 address_state=APIHelper.SKIP,
                 address_zip=APIHelper.SKIP,
                 description=APIHelper.SKIP,
                 phone=APIHelper.SKIP,
                 email=APIHelper.SKIP,
                 metadata=APIHelper.SKIP):
        """Constructor for the AddressEditableIntl class"""

        # Initialize members of the class
        self.address_line_1 = address_line_1 
        if address_line_2 is not APIHelper.SKIP:
            self.address_line_2 = address_line_2 
        if address_city is not APIHelper.SKIP:
            self.address_city = address_city 
        if address_state is not APIHelper.SKIP:
            self.address_state = address_state 
        if address_zip is not APIHelper.SKIP:
            self.address_zip = address_zip 
        if description is not APIHelper.SKIP:
            self.description = description 
        self.name = name 
        self.company = company 
        if phone is not APIHelper.SKIP:
            self.phone = phone 
        if email is not APIHelper.SKIP:
            self.email = email 
        self.address_country = address_country 
        if metadata is not APIHelper.SKIP:
            self.metadata = metadata 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        address_line_1 = dictionary.get("address_line1") if dictionary.get("address_line1") else None
        name = dictionary.get("name") if dictionary.get("name") else None
        company = dictionary.get("company") if dictionary.get("company") else None
        address_country = dictionary.get("address_country") if dictionary.get("address_country") else None
        address_line_2 = dictionary.get("address_line2") if "address_line2" in dictionary.keys() else APIHelper.SKIP
        address_city = dictionary.get("address_city") if "address_city" in dictionary.keys() else APIHelper.SKIP
        address_state = dictionary.get("address_state") if "address_state" in dictionary.keys() else APIHelper.SKIP
        address_zip = dictionary.get("address_zip") if "address_zip" in dictionary.keys() else APIHelper.SKIP
        description = dictionary.get("description") if "description" in dictionary.keys() else APIHelper.SKIP
        phone = dictionary.get("phone") if "phone" in dictionary.keys() else APIHelper.SKIP
        email = dictionary.get("email") if "email" in dictionary.keys() else APIHelper.SKIP
        metadata = dictionary.get("metadata") if dictionary.get("metadata") else APIHelper.SKIP
        # Return an object of this model
        return cls(address_line_1,
                   name,
                   company,
                   address_country,
                   address_line_2,
                   address_city,
                   address_state,
                   address_zip,
                   description,
                   phone,
                   email,
                   metadata)
