# -*- coding: utf-8 -*-

"""
lob

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from lob.api_helper import APIHelper


class AddressUs(object):

    """Implementation of the 'address_us' model.

    TODO: type model description here.

    Attributes:
        date_created (datetime): A timestamp in ISO 8601 format of the date
            the resource was created.
        date_modified (datetime): A timestamp in ISO 8601 format of the date
            the resource was last modified.
        deleted (bool): Only returned if the resource has been successfully
            deleted.
        object (str): Value is resource type.
        id (str): Unique identifier prefixed with `adr_`.
        description (str): An internal description that identifies this
            resource. Must be no longer than 255 characters.
        name (str): Either `name` or `company` is required, you may also add
            both. Must be no longer than 40 characters. If both `name` and
            `company` are provided, they will be printed on two separate lines
            above the rest of the address.
        company (str): Either `name` or `company` is required, you may also
            add both. Must be no longer than 40 characters. If both `name` and
            `company` are provided, they will be printed on two separate lines
            above the rest of the address. This field can be used for any
            secondary recipient information which is not part of the actual
            mailing address (Company Name, Department, Attention Line, etc).
        phone (str): Must be no longer than 40 characters.
        email (str): Must be no longer than 100 characters.
        address_line_1 (str): The primary number, street name, and directional
            information.
        address_line_2 (str): An optional field containing any information
            which can't fit into line 1.
        address_city (str): TODO: type description here.
        address_state (str): 2 letter state short-name code
        address_zip (str): Must follow the ZIP format of `12345` or ZIP+4
            format of `12345-1234`.
        address_country (AddressCountryEnum): TODO: type description here.
        metadata (Dict[str, str]): Use metadata to store custom information
            for tagging and labeling back to your internal systems. Must be an
            object with up to 20 key-value pairs. Keys must be at most 40
            characters and values must be at most 500 characters. Neither can
            contain the characters `"` and `\`. i.e. '{"customer_id" :
            "NEWYORK2015"}' Nested objects are not supported.  See
            [Metadata](#section/Metadata) for more information.
        recipient_moved (bool): Only returned for accounts on certain <a
            href="https://dashboard.lob.com/#/settings/editions"
            target="_blank">Print &amp; Mail Editions</a>. Value is `true` if
            the address was altered because the recipient filed for a <a
            href="#tag/National-Change-of-Address">National Change of Address
            Linkage (NCOALink)</a>, `false` if the NCOALink check was run but
            no altered address was found, and `null` if the NCOALink check was
            not run. The NCOALink check does not happen for non-US addresses,
            for non-deliverable US addresses, or for addresses created before
            the NCOALink feature was added to your account.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "date_created": 'date_created',
        "date_modified": 'date_modified',
        "object": 'object',
        "id": 'id',
        "name": 'name',
        "company": 'company',
        "address_line_1": 'address_line1',
        "address_city": 'address_city',
        "address_state": 'address_state',
        "address_zip": 'address_zip',
        "deleted": 'deleted',
        "description": 'description',
        "phone": 'phone',
        "email": 'email',
        "address_line_2": 'address_line2',
        "address_country": 'address_country',
        "metadata": 'metadata',
        "recipient_moved": 'recipient_moved'
    }

    _optionals = [
        'deleted',
        'description',
        'phone',
        'email',
        'address_line_2',
        'address_country',
        'metadata',
        'recipient_moved',
    ]

    _nullables = [
        'description',
        'name',
        'company',
        'phone',
        'email',
        'address_line_2',
        'recipient_moved',
    ]

    def __init__(self,
                 date_created=None,
                 date_modified=None,
                 id=None,
                 name=None,
                 company=None,
                 address_line_1=None,
                 address_city=None,
                 address_state=None,
                 address_zip=None,
                 deleted=APIHelper.SKIP,
                 description=APIHelper.SKIP,
                 phone=APIHelper.SKIP,
                 email=APIHelper.SKIP,
                 address_line_2=APIHelper.SKIP,
                 address_country=APIHelper.SKIP,
                 metadata=APIHelper.SKIP,
                 recipient_moved=APIHelper.SKIP):
        """Constructor for the AddressUs class"""

        # Initialize members of the class
        self.date_created = APIHelper.apply_datetime_converter(date_created, APIHelper.RFC3339DateTime) if date_created else None 
        self.date_modified = APIHelper.apply_datetime_converter(date_modified, APIHelper.RFC3339DateTime) if date_modified else None 
        if deleted is not APIHelper.SKIP:
            self.deleted = deleted 
        self.object = 'address' 
        self.id = id 
        if description is not APIHelper.SKIP:
            self.description = description 
        self.name = name 
        self.company = company 
        if phone is not APIHelper.SKIP:
            self.phone = phone 
        if email is not APIHelper.SKIP:
            self.email = email 
        self.address_line_1 = address_line_1 
        if address_line_2 is not APIHelper.SKIP:
            self.address_line_2 = address_line_2 
        self.address_city = address_city 
        self.address_state = address_state 
        self.address_zip = address_zip 
        if address_country is not APIHelper.SKIP:
            self.address_country = address_country 
        if metadata is not APIHelper.SKIP:
            self.metadata = metadata 
        if recipient_moved is not APIHelper.SKIP:
            self.recipient_moved = recipient_moved 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        date_created = APIHelper.RFC3339DateTime.from_value(dictionary.get("date_created")).datetime if dictionary.get("date_created") else None
        date_modified = APIHelper.RFC3339DateTime.from_value(dictionary.get("date_modified")).datetime if dictionary.get("date_modified") else None
        id = dictionary.get("id") if dictionary.get("id") else None
        name = dictionary.get("name") if dictionary.get("name") else None
        company = dictionary.get("company") if dictionary.get("company") else None
        address_line_1 = dictionary.get("address_line1") if dictionary.get("address_line1") else None
        address_city = dictionary.get("address_city") if dictionary.get("address_city") else None
        address_state = dictionary.get("address_state") if dictionary.get("address_state") else None
        address_zip = dictionary.get("address_zip") if dictionary.get("address_zip") else None
        deleted = dictionary.get("deleted") if "deleted" in dictionary.keys() else APIHelper.SKIP
        description = dictionary.get("description") if "description" in dictionary.keys() else APIHelper.SKIP
        phone = dictionary.get("phone") if "phone" in dictionary.keys() else APIHelper.SKIP
        email = dictionary.get("email") if "email" in dictionary.keys() else APIHelper.SKIP
        address_line_2 = dictionary.get("address_line2") if "address_line2" in dictionary.keys() else APIHelper.SKIP
        address_country = dictionary.get("address_country") if dictionary.get("address_country") else APIHelper.SKIP
        metadata = dictionary.get("metadata") if dictionary.get("metadata") else APIHelper.SKIP
        recipient_moved = dictionary.get("recipient_moved") if "recipient_moved" in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(date_created,
                   date_modified,
                   id,
                   name,
                   company,
                   address_line_1,
                   address_city,
                   address_state,
                   address_zip,
                   deleted,
                   description,
                   phone,
                   email,
                   address_line_2,
                   address_country,
                   metadata,
                   recipient_moved)

    @classmethod
    def validate(cls, dictionary):
        """Validates dictionary against class required properties

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            boolean : if dictionary is valid contains required properties.

        """

        if isinstance(dictionary, cls):
            return APIHelper.is_valid_type(value=dictionary.date_created,
                                           type_callable=lambda value: isinstance(value, APIHelper.RFC3339DateTime)) \
                and APIHelper.is_valid_type(value=dictionary.date_modified,
                                            type_callable=lambda value: isinstance(value, APIHelper.RFC3339DateTime)) \
                and APIHelper.is_valid_type(value=dictionary.object,
                                            type_callable=lambda value: isinstance(value, str)) \
                and APIHelper.is_valid_type(value=dictionary.id,
                                            type_callable=lambda value: isinstance(value, str)) \
                and APIHelper.is_valid_type(value=dictionary.name,
                                            type_callable=lambda value: isinstance(value, str),
                                            is_value_nullable=True) \
                and APIHelper.is_valid_type(value=dictionary.company,
                                            type_callable=lambda value: isinstance(value, str),
                                            is_value_nullable=True) \
                and APIHelper.is_valid_type(value=dictionary.address_line_1,
                                            type_callable=lambda value: isinstance(value, str)) \
                and APIHelper.is_valid_type(value=dictionary.address_city,
                                            type_callable=lambda value: isinstance(value, str)) \
                and APIHelper.is_valid_type(value=dictionary.address_state,
                                            type_callable=lambda value: isinstance(value, str)) \
                and APIHelper.is_valid_type(value=dictionary.address_zip,
                                            type_callable=lambda value: isinstance(value, str))

        if not isinstance(dictionary, dict):
            return False

        return APIHelper.is_valid_type(value=dictionary.get('date_created'),
                                       type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('date_modified'),
                                        type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('object'),
                                        type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('id'),
                                        type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('name'),
                                        type_callable=lambda value: isinstance(value, str),
                                        is_value_nullable=True) \
            and APIHelper.is_valid_type(value=dictionary.get('company'),
                                        type_callable=lambda value: isinstance(value, str),
                                        is_value_nullable=True) \
            and APIHelper.is_valid_type(value=dictionary.get('address_line1'),
                                        type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('address_city'),
                                        type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('address_state'),
                                        type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('address_zip'),
                                        type_callable=lambda value: isinstance(value, str))
