# -*- coding: utf-8 -*-

"""
lob

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from lob.api_helper import APIHelper


class CampaignWritable(object):

    """Implementation of the 'campaign_writable' model.

    TODO: type model description here.

    Attributes:
        billing_group_id (str): Unique identifier prefixed with `bg_`.
        name (str): Name of the campaign.
        description (str): An internal description that identifies this
            resource. Must be no longer than 255 characters.
        schedule_type (str): How the campaign should be scheduled. Only value
            available today is `immediate`.
        target_delivery_date (datetime): If `schedule_type` is
            `target_delivery_date`, provide a targeted delivery date for mail
            pieces in this campaign.
        send_date (datetime): If `schedule_type` is `scheduled_send_date`,
            provide a date to send this campaign.
        cancel_window_campaign_minutes (int): A window, in minutes, within
            which the campaign can be canceled.
        metadata (Dict[str, str]): Use metadata to store custom information
            for tagging and labeling back to your internal systems. Must be an
            object with up to 20 key-value pairs. Keys must be at most 40
            characters and values must be at most 500 characters. Neither can
            contain the characters `"` and `\`. i.e. '{"customer_id" :
            "NEWYORK2015"}' Nested objects are not supported.  See
            [Metadata](#section/Metadata) for more information.
        use_type (object): TODO: type description here.
        auto_cancel_if_ncoa (bool): Whether or not a mail piece should be
            automatically canceled and not sent if the address is updated via
            NCOA.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "name": 'name',
        "schedule_type": 'schedule_type',
        "use_type": 'use_type',
        "billing_group_id": 'billing_group_id',
        "description": 'description',
        "target_delivery_date": 'target_delivery_date',
        "send_date": 'send_date',
        "cancel_window_campaign_minutes": 'cancel_window_campaign_minutes',
        "metadata": 'metadata',
        "auto_cancel_if_ncoa": 'auto_cancel_if_ncoa'
    }

    _optionals = [
        'billing_group_id',
        'description',
        'target_delivery_date',
        'send_date',
        'cancel_window_campaign_minutes',
        'metadata',
        'auto_cancel_if_ncoa',
    ]

    _nullables = [
        'billing_group_id',
        'description',
        'target_delivery_date',
        'send_date',
        'cancel_window_campaign_minutes',
    ]

    def __init__(self,
                 name=None,
                 use_type=None,
                 billing_group_id=APIHelper.SKIP,
                 description=APIHelper.SKIP,
                 target_delivery_date=APIHelper.SKIP,
                 send_date=APIHelper.SKIP,
                 cancel_window_campaign_minutes=APIHelper.SKIP,
                 metadata=APIHelper.SKIP,
                 auto_cancel_if_ncoa=APIHelper.SKIP):
        """Constructor for the CampaignWritable class"""

        # Initialize members of the class
        if billing_group_id is not APIHelper.SKIP:
            self.billing_group_id = billing_group_id 
        self.name = name 
        if description is not APIHelper.SKIP:
            self.description = description 
        self.schedule_type = 'immediate' 
        if target_delivery_date is not APIHelper.SKIP:
            self.target_delivery_date = APIHelper.apply_datetime_converter(target_delivery_date, APIHelper.RFC3339DateTime) if target_delivery_date else None 
        if send_date is not APIHelper.SKIP:
            self.send_date = APIHelper.apply_datetime_converter(send_date, APIHelper.RFC3339DateTime) if send_date else None 
        if cancel_window_campaign_minutes is not APIHelper.SKIP:
            self.cancel_window_campaign_minutes = cancel_window_campaign_minutes 
        if metadata is not APIHelper.SKIP:
            self.metadata = metadata 
        self.use_type = use_type 
        if auto_cancel_if_ncoa is not APIHelper.SKIP:
            self.auto_cancel_if_ncoa = auto_cancel_if_ncoa 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        name = dictionary.get("name") if dictionary.get("name") else None
        use_type = dictionary.get("use_type") if dictionary.get("use_type") else None
        billing_group_id = dictionary.get("billing_group_id") if "billing_group_id" in dictionary.keys() else APIHelper.SKIP
        description = dictionary.get("description") if "description" in dictionary.keys() else APIHelper.SKIP
        if 'target_delivery_date' in dictionary.keys():
            target_delivery_date = APIHelper.RFC3339DateTime.from_value(dictionary.get("target_delivery_date")).datetime if dictionary.get("target_delivery_date") else None
        else:
            target_delivery_date = APIHelper.SKIP
        if 'send_date' in dictionary.keys():
            send_date = APIHelper.RFC3339DateTime.from_value(dictionary.get("send_date")).datetime if dictionary.get("send_date") else None
        else:
            send_date = APIHelper.SKIP
        cancel_window_campaign_minutes = dictionary.get("cancel_window_campaign_minutes") if "cancel_window_campaign_minutes" in dictionary.keys() else APIHelper.SKIP
        metadata = dictionary.get("metadata") if dictionary.get("metadata") else APIHelper.SKIP
        auto_cancel_if_ncoa = dictionary.get("auto_cancel_if_ncoa") if "auto_cancel_if_ncoa" in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(name,
                   use_type,
                   billing_group_id,
                   description,
                   target_delivery_date,
                   send_date,
                   cancel_window_campaign_minutes,
                   metadata,
                   auto_cancel_if_ncoa)
