# -*- coding: utf-8 -*-

"""
lob

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from lob.api_helper import APIHelper
from lob.models.orientation_enum import OrientationEnum
from lob.models.thestatusofthecard_enum import ThestatusofthecardEnum
from lob.models.thumbnail import Thumbnail


class Card(object):

    """Implementation of the 'card' model.

    TODO: type model description here.

    Attributes:
        date_created (datetime): A timestamp in ISO 8601 format of the date
            the resource was created.
        date_modified (datetime): A timestamp in ISO 8601 format of the date
            the resource was last modified.
        deleted (bool): Only returned if the resource has been successfully
            deleted.
        object (str): Value is resource type.
        description (str): Description of the card.
        size (Size1Enum): TODO: type description here.
        id (str): Unique identifier prefixed with `card_`.
        url (str): The signed link for the card.
        auto_reorder (bool): True if the cards should be auto-reordered.
        reorder_quantity (int): The number of cards to be reordered.
        raw_url (str): The raw URL of the card.
        front_original_url (str): The original URL of the front template.
        back_original_url (str): The original URL of the back template.
        thumbnails (List[Thumbnail]): TODO: type description here.
        available_quantity (int): The available quantity of cards.
        pending_quantity (int): The pending quantity of cards.
        status (ThestatusofthecardEnum): TODO: type description here.
        orientation (OrientationEnum): TODO: type description here.
        threshold_amount (int): The threshold amount of the card

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "date_created": 'date_created',
        "date_modified": 'date_modified',
        "object": 'object',
        "description": 'description',
        "id": 'id',
        "url": 'url',
        "auto_reorder": 'auto_reorder',
        "reorder_quantity": 'reorder_quantity',
        "raw_url": 'raw_url',
        "front_original_url": 'front_original_url',
        "back_original_url": 'back_original_url',
        "thumbnails": 'thumbnails',
        "available_quantity": 'available_quantity',
        "pending_quantity": 'pending_quantity',
        "status": 'status',
        "orientation": 'orientation',
        "threshold_amount": 'threshold_amount',
        "deleted": 'deleted',
        "size": 'size'
    }

    _optionals = [
        'deleted',
        'size',
    ]

    _nullables = [
        'description',
        'reorder_quantity',
    ]

    def __init__(self,
                 date_created=None,
                 date_modified=None,
                 description=None,
                 id=None,
                 url=None,
                 auto_reorder=None,
                 reorder_quantity=None,
                 raw_url=None,
                 front_original_url=None,
                 back_original_url=None,
                 thumbnails=None,
                 available_quantity=None,
                 pending_quantity=None,
                 status=None,
                 orientation=None,
                 threshold_amount=None,
                 deleted=APIHelper.SKIP,
                 size=APIHelper.SKIP):
        """Constructor for the Card class"""

        # Initialize members of the class
        self.date_created = APIHelper.apply_datetime_converter(date_created, APIHelper.RFC3339DateTime) if date_created else None 
        self.date_modified = APIHelper.apply_datetime_converter(date_modified, APIHelper.RFC3339DateTime) if date_modified else None 
        if deleted is not APIHelper.SKIP:
            self.deleted = deleted 
        self.object = 'card' 
        self.description = description 
        if size is not APIHelper.SKIP:
            self.size = size 
        self.id = id 
        self.url = url 
        self.auto_reorder = auto_reorder 
        self.reorder_quantity = reorder_quantity 
        self.raw_url = raw_url 
        self.front_original_url = front_original_url 
        self.back_original_url = back_original_url 
        self.thumbnails = thumbnails 
        self.available_quantity = available_quantity 
        self.pending_quantity = pending_quantity 
        self.status = status 
        self.orientation = orientation 
        self.threshold_amount = threshold_amount 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        date_created = APIHelper.RFC3339DateTime.from_value(dictionary.get("date_created")).datetime if dictionary.get("date_created") else None
        date_modified = APIHelper.RFC3339DateTime.from_value(dictionary.get("date_modified")).datetime if dictionary.get("date_modified") else None
        description = dictionary.get("description") if dictionary.get("description") else None
        id = dictionary.get("id") if dictionary.get("id") else None
        url = dictionary.get("url") if dictionary.get("url") else None
        auto_reorder = dictionary.get("auto_reorder") if "auto_reorder" in dictionary.keys() else None
        reorder_quantity = dictionary.get("reorder_quantity") if dictionary.get("reorder_quantity") else None
        raw_url = dictionary.get("raw_url") if dictionary.get("raw_url") else None
        front_original_url = dictionary.get("front_original_url") if dictionary.get("front_original_url") else None
        back_original_url = dictionary.get("back_original_url") if dictionary.get("back_original_url") else None
        thumbnails = None
        if dictionary.get('thumbnails') is not None:
            thumbnails = [Thumbnail.from_dictionary(x) for x in dictionary.get('thumbnails')]
        available_quantity = dictionary.get("available_quantity") if dictionary.get("available_quantity") else None
        pending_quantity = dictionary.get("pending_quantity") if dictionary.get("pending_quantity") else None
        status = dictionary.get("status") if dictionary.get("status") else None
        orientation = dictionary.get("orientation") if dictionary.get("orientation") else None
        threshold_amount = dictionary.get("threshold_amount") if dictionary.get("threshold_amount") else None
        deleted = dictionary.get("deleted") if "deleted" in dictionary.keys() else APIHelper.SKIP
        size = dictionary.get("size") if dictionary.get("size") else APIHelper.SKIP
        # Return an object of this model
        return cls(date_created,
                   date_modified,
                   description,
                   id,
                   url,
                   auto_reorder,
                   reorder_quantity,
                   raw_url,
                   front_original_url,
                   back_original_url,
                   thumbnails,
                   available_quantity,
                   pending_quantity,
                   status,
                   orientation,
                   threshold_amount,
                   deleted,
                   size)

    @classmethod
    def validate(cls, dictionary):
        """Validates dictionary against class required properties

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            boolean : if dictionary is valid contains required properties.

        """

        if isinstance(dictionary, cls):
            return APIHelper.is_valid_type(value=dictionary.date_created,
                                           type_callable=lambda value: isinstance(value, APIHelper.RFC3339DateTime)) \
                and APIHelper.is_valid_type(value=dictionary.date_modified,
                                            type_callable=lambda value: isinstance(value, APIHelper.RFC3339DateTime)) \
                and APIHelper.is_valid_type(value=dictionary.object,
                                            type_callable=lambda value: isinstance(value, str)) \
                and APIHelper.is_valid_type(value=dictionary.description,
                                            type_callable=lambda value: isinstance(value, str),
                                            is_value_nullable=True) \
                and APIHelper.is_valid_type(value=dictionary.id,
                                            type_callable=lambda value: isinstance(value, str)) \
                and APIHelper.is_valid_type(value=dictionary.url,
                                            type_callable=lambda value: isinstance(value, str)) \
                and APIHelper.is_valid_type(value=dictionary.auto_reorder,
                                            type_callable=lambda value: isinstance(value, bool)) \
                and APIHelper.is_valid_type(value=dictionary.reorder_quantity,
                                            type_callable=lambda value: isinstance(value, int),
                                            is_value_nullable=True) \
                and APIHelper.is_valid_type(value=dictionary.raw_url,
                                            type_callable=lambda value: isinstance(value, str)) \
                and APIHelper.is_valid_type(value=dictionary.front_original_url,
                                            type_callable=lambda value: isinstance(value, str)) \
                and APIHelper.is_valid_type(value=dictionary.back_original_url,
                                            type_callable=lambda value: isinstance(value, str)) \
                and APIHelper.is_valid_type(value=dictionary.thumbnails,
                                            type_callable=lambda value: Thumbnail.validate(value),
                                            is_model_dict=True,
                                            is_inner_model_dict=True) \
                and APIHelper.is_valid_type(value=dictionary.available_quantity,
                                            type_callable=lambda value: isinstance(value, int)) \
                and APIHelper.is_valid_type(value=dictionary.pending_quantity,
                                            type_callable=lambda value: isinstance(value, int)) \
                and APIHelper.is_valid_type(value=dictionary.status,
                                            type_callable=lambda value: ThestatusofthecardEnum.validate(value)) \
                and APIHelper.is_valid_type(value=dictionary.orientation,
                                            type_callable=lambda value: OrientationEnum.validate(value)) \
                and APIHelper.is_valid_type(value=dictionary.threshold_amount,
                                            type_callable=lambda value: isinstance(value, int))

        if not isinstance(dictionary, dict):
            return False

        return APIHelper.is_valid_type(value=dictionary.get('date_created'),
                                       type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('date_modified'),
                                        type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('object'),
                                        type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('description'),
                                        type_callable=lambda value: isinstance(value, str),
                                        is_value_nullable=True) \
            and APIHelper.is_valid_type(value=dictionary.get('id'),
                                        type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('url'),
                                        type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('auto_reorder'),
                                        type_callable=lambda value: isinstance(value, bool)) \
            and APIHelper.is_valid_type(value=dictionary.get('reorder_quantity'),
                                        type_callable=lambda value: isinstance(value, int),
                                        is_value_nullable=True) \
            and APIHelper.is_valid_type(value=dictionary.get('raw_url'),
                                        type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('front_original_url'),
                                        type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('back_original_url'),
                                        type_callable=lambda value: isinstance(value, str)) \
            and APIHelper.is_valid_type(value=dictionary.get('thumbnails'),
                                        type_callable=lambda value: Thumbnail.validate(value),
                                        is_model_dict=True,
                                        is_inner_model_dict=True) \
            and APIHelper.is_valid_type(value=dictionary.get('available_quantity'),
                                        type_callable=lambda value: isinstance(value, int)) \
            and APIHelper.is_valid_type(value=dictionary.get('pending_quantity'),
                                        type_callable=lambda value: isinstance(value, int)) \
            and APIHelper.is_valid_type(value=dictionary.get('status'),
                                        type_callable=lambda value: ThestatusofthecardEnum.validate(value)) \
            and APIHelper.is_valid_type(value=dictionary.get('orientation'),
                                        type_callable=lambda value: OrientationEnum.validate(value)) \
            and APIHelper.is_valid_type(value=dictionary.get('threshold_amount'),
                                        type_callable=lambda value: isinstance(value, int))
