# -*- coding: utf-8 -*-

"""
lob

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""


class EventEnum(object):

    """Implementation of the 'Event' enum.

    Find the full table [here](#tag/Tracking-Events). A detailed substatus
    about the event:
    * `package_accepted` - Package has been accepted into the carrier network
    for delivery.
    * `package_arrived` - Package has arrived at an intermediate location in
    the carrier network.
    * `package_departed` - Package has departed from an intermediate location
    in the carrier network.
    * `package_processing` - Package is processing at an intermediate location
    in the carrier network.
    * `package_processed` - Package has been processed at an intermediate
    location.
    * `package_in_local_area` - Package is at a location near the end
    destination.
    * `delivery_scheduled` - Package is scheduled for delivery.
    * `out_for_delivery` - Package is out for delivery.
    * `pickup_available` - Package is available for pickup at carrier
    location.
    * `delivered` - Package has been delivered.
    * `package_forwarded` - Package has been forwarded.
    * `returned_to_sender` - Package is to be returned to sender.
    * `address_issue` - Address information is incorrect. Contact carrier to
    ensure delivery.
    * `contact_carrier` - Contact the carrier for more information.
    * `delayed` - Delivery of package is delayed.
    * `delivery_attempted` - Delivery of package has been attempted. Contact
    carrier to ensure delivery.
    * `delivery_rescheduled` - Delivery of package has been rescheduled.
    * `location_inaccessible` - Delivery location inaccessible to carrier.
    Contact carrier to ensure delivery.
    * `notice_left` - Carrier left notice during attempted delivery. Follow
    carrier instructions on notice.
    * `package_damaged` - Package has been damaged. Contact carrier for more
    details.
    * `package_disposed` - Package has been disposed.
    * `package_held` - Package held at carrier location. Contact carrier for
    more details.
    * `package_lost` - Package has been lost. Contact carrier for more
    details.
    * `package_unclaimed` - Package is unclaimed.
    * `package_undeliverable` - Package is not able to be delivered.
    * `reschedule_delivery` - Contact carrier to reschedule delivery.
    * `other` - Unrecognized carrier status.

    Attributes:
        PACKAGE_ACCEPTED: TODO: type description here.
        PACKAGE_ARRIVED: TODO: type description here.
        PACKAGE_DEPARTED: TODO: type description here.
        PACKAGE_PROCESSING: TODO: type description here.
        PACKAGE_PROCESSED: TODO: type description here.
        PACKAGE_IN_LOCAL_AREA: TODO: type description here.
        DELIVERY_SCHEDULED: TODO: type description here.
        OUT_FOR_DELIVERY: TODO: type description here.
        PICKUP_AVAILABLE: TODO: type description here.
        DELIVERED: TODO: type description here.
        PACKAGE_FORWARDED: TODO: type description here.
        RETURNED_TO_SENDER: TODO: type description here.
        ADDRESS_ISSUE: TODO: type description here.
        CONTACT_CARRIER: TODO: type description here.
        DELAYED: TODO: type description here.
        DELIVERY_ATTEMPTED: TODO: type description here.
        DELIVERY_RESCHEDULED: TODO: type description here.
        LOCATION_INACCESSIBLE: TODO: type description here.
        NOTICE_LEFT: TODO: type description here.
        PACKAGE_DAMAGED: TODO: type description here.
        PACKAGE_DISPOSED: TODO: type description here.
        PACKAGE_HELD: TODO: type description here.
        PACKAGE_LOST: TODO: type description here.
        PACKAGE_UNCLAIMED: TODO: type description here.
        PACKAGE_UNDELIVERABLE: TODO: type description here.
        RESCHEDULE_DELIVERY: TODO: type description here.
        OTHER: TODO: type description here.

    """
    _all_values = ['package_accepted', 'package_arrived', 'package_departed', 'package_processing', 'package_processed', 'package_in_local_area', 'delivery_scheduled', 'out_for_delivery', 'pickup_available', 'delivered', 'package_forwarded', 'returned_to_sender', 'address_issue', 'contact_carrier', 'delayed', 'delivery_attempted', 'delivery_rescheduled', 'location_inaccessible', 'notice_left', 'package_damaged', 'package_disposed', 'package_held', 'package_lost', 'package_unclaimed', 'package_undeliverable', 'reschedule_delivery', 'other']
    PACKAGE_ACCEPTED = 'package_accepted'

    PACKAGE_ARRIVED = 'package_arrived'

    PACKAGE_DEPARTED = 'package_departed'

    PACKAGE_PROCESSING = 'package_processing'

    PACKAGE_PROCESSED = 'package_processed'

    PACKAGE_IN_LOCAL_AREA = 'package_in_local_area'

    DELIVERY_SCHEDULED = 'delivery_scheduled'

    OUT_FOR_DELIVERY = 'out_for_delivery'

    PICKUP_AVAILABLE = 'pickup_available'

    DELIVERED = 'delivered'

    PACKAGE_FORWARDED = 'package_forwarded'

    RETURNED_TO_SENDER = 'returned_to_sender'

    ADDRESS_ISSUE = 'address_issue'

    CONTACT_CARRIER = 'contact_carrier'

    DELAYED = 'delayed'

    DELIVERY_ATTEMPTED = 'delivery_attempted'

    DELIVERY_RESCHEDULED = 'delivery_rescheduled'

    LOCATION_INACCESSIBLE = 'location_inaccessible'

    NOTICE_LEFT = 'notice_left'

    PACKAGE_DAMAGED = 'package_damaged'

    PACKAGE_DISPOSED = 'package_disposed'

    PACKAGE_HELD = 'package_held'

    PACKAGE_LOST = 'package_lost'

    PACKAGE_UNCLAIMED = 'package_unclaimed'

    PACKAGE_UNDELIVERABLE = 'package_undeliverable'

    RESCHEDULE_DELIVERY = 'reschedule_delivery'

    OTHER = 'other'

    @classmethod
    def validate(cls, value):
        """Validates value contains in enum

        Args:
            value: the value to be validated

        Returns:
            boolean : if value is valid enum values.

        """
        return value in cls._all_values
   