# -*- coding: utf-8 -*-

"""
lob

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
import dateutil.parser

from lob.api_helper import APIHelper
from lob.models.thumbnail import Thumbnail


class LetterGeneratedBase(object):

    """Implementation of the 'letter_generated_base' model.

    TODO: type model description here.

    Attributes:
        to (object): TODO: type description here.
        carrier (str): TODO: type description here.
        thumbnails (List[Thumbnail]): TODO: type description here.
        expected_delivery_date (date): A date in YYYY-MM-DD format of the
            mailpiece's expected delivery date based on its `send_date`.
        date_created (datetime): A timestamp in ISO 8601 format of the date
            the resource was created.
        date_modified (datetime): A timestamp in ISO 8601 format of the date
            the resource was last modified.
        deleted (bool): Only returned if the resource has been successfully
            deleted.
        mfrom (object): TODO: type description here.
        url (str): A [signed link](#section/Asset-URLs) served over HTTPS. The
            link returned will expire in 30 days to prevent mis-sharing. Each
            time a GET request is initiated, a new signed URL will be
            generated.
        id (str): Unique identifier prefixed with `ltr_`.
        template_id (str): TODO: type description here.
        template_version_id (str): TODO: type description here.
        campaign_id (str): The unique ID of the associated campaign if the
            resource was generated from a campaign.
        use_type (object): TODO: type description here.
        fsc (bool): This is in beta. Contact support@lob.com or your account
            contact to learn more. Not available for `A4` letter size.
        status (ThestatusofthebuckslipEnum): TODO: type description here.
        failure_reason (str): A string describing the reason for failure if
            the letter failed to render.
        object (Object8Enum): TODO: type description here.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "to": 'to',
        "carrier": 'carrier',
        "mfrom": 'from',
        "id": 'id',
        "use_type": 'use_type',
        "thumbnails": 'thumbnails',
        "expected_delivery_date": 'expected_delivery_date',
        "date_created": 'date_created',
        "date_modified": 'date_modified',
        "deleted": 'deleted',
        "url": 'url',
        "template_id": 'template_id',
        "template_version_id": 'template_version_id',
        "campaign_id": 'campaign_id',
        "fsc": 'fsc',
        "status": 'status',
        "failure_reason": 'failure_reason',
        "object": 'object'
    }

    _optionals = [
        'thumbnails',
        'expected_delivery_date',
        'date_created',
        'date_modified',
        'deleted',
        'url',
        'template_id',
        'template_version_id',
        'campaign_id',
        'fsc',
        'status',
        'failure_reason',
        'object',
    ]

    _nullables = [
        'campaign_id',
        'failure_reason',
    ]

    def __init__(self,
                 to=None,
                 mfrom=None,
                 id=None,
                 use_type=None,
                 thumbnails=APIHelper.SKIP,
                 expected_delivery_date=APIHelper.SKIP,
                 date_created=APIHelper.SKIP,
                 date_modified=APIHelper.SKIP,
                 deleted=APIHelper.SKIP,
                 url=APIHelper.SKIP,
                 template_id=APIHelper.SKIP,
                 template_version_id=APIHelper.SKIP,
                 campaign_id=APIHelper.SKIP,
                 fsc=False,
                 status=APIHelper.SKIP,
                 failure_reason=APIHelper.SKIP,
                 object=APIHelper.SKIP):
        """Constructor for the LetterGeneratedBase class"""

        # Initialize members of the class
        self.to = to 
        self.carrier = 'USPS' 
        if thumbnails is not APIHelper.SKIP:
            self.thumbnails = thumbnails 
        if expected_delivery_date is not APIHelper.SKIP:
            self.expected_delivery_date = expected_delivery_date 
        if date_created is not APIHelper.SKIP:
            self.date_created = APIHelper.apply_datetime_converter(date_created, APIHelper.RFC3339DateTime) if date_created else None 
        if date_modified is not APIHelper.SKIP:
            self.date_modified = APIHelper.apply_datetime_converter(date_modified, APIHelper.RFC3339DateTime) if date_modified else None 
        if deleted is not APIHelper.SKIP:
            self.deleted = deleted 
        self.mfrom = mfrom 
        if url is not APIHelper.SKIP:
            self.url = url 
        self.id = id 
        if template_id is not APIHelper.SKIP:
            self.template_id = template_id 
        if template_version_id is not APIHelper.SKIP:
            self.template_version_id = template_version_id 
        if campaign_id is not APIHelper.SKIP:
            self.campaign_id = campaign_id 
        self.use_type = use_type 
        self.fsc = fsc 
        if status is not APIHelper.SKIP:
            self.status = status 
        if failure_reason is not APIHelper.SKIP:
            self.failure_reason = failure_reason 
        if object is not APIHelper.SKIP:
            self.object = object 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        to = dictionary.get("to") if dictionary.get("to") else None
        mfrom = dictionary.get("from") if dictionary.get("from") else None
        id = dictionary.get("id") if dictionary.get("id") else None
        use_type = dictionary.get("use_type") if dictionary.get("use_type") else None
        thumbnails = None
        if dictionary.get('thumbnails') is not None:
            thumbnails = [Thumbnail.from_dictionary(x) for x in dictionary.get('thumbnails')]
        else:
            thumbnails = APIHelper.SKIP
        expected_delivery_date = dateutil.parser.parse(dictionary.get('expected_delivery_date')).date() if dictionary.get('expected_delivery_date') else APIHelper.SKIP
        date_created = APIHelper.RFC3339DateTime.from_value(dictionary.get("date_created")).datetime if dictionary.get("date_created") else APIHelper.SKIP
        date_modified = APIHelper.RFC3339DateTime.from_value(dictionary.get("date_modified")).datetime if dictionary.get("date_modified") else APIHelper.SKIP
        deleted = dictionary.get("deleted") if "deleted" in dictionary.keys() else APIHelper.SKIP
        url = dictionary.get("url") if dictionary.get("url") else APIHelper.SKIP
        template_id = dictionary.get("template_id") if dictionary.get("template_id") else APIHelper.SKIP
        template_version_id = dictionary.get("template_version_id") if dictionary.get("template_version_id") else APIHelper.SKIP
        campaign_id = dictionary.get("campaign_id") if "campaign_id" in dictionary.keys() else APIHelper.SKIP
        fsc = dictionary.get("fsc") if dictionary.get("fsc") else False
        status = dictionary.get("status") if dictionary.get("status") else APIHelper.SKIP
        failure_reason = dictionary.get("failure_reason") if "failure_reason" in dictionary.keys() else APIHelper.SKIP
        object = dictionary.get("object") if dictionary.get("object") else APIHelper.SKIP
        # Return an object of this model
        return cls(to,
                   mfrom,
                   id,
                   use_type,
                   thumbnails,
                   expected_delivery_date,
                   date_created,
                   date_modified,
                   deleted,
                   url,
                   template_id,
                   template_version_id,
                   campaign_id,
                   fsc,
                   status,
                   failure_reason,
                   object)
