# -*- coding: utf-8 -*-

"""
lob

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
import dateutil.parser

from lob.api_helper import APIHelper
from lob.models.address_us import AddressUs
from lob.models.thumbnail import Thumbnail
from lob.models.tracking_event_normal import TrackingEventNormal


class Postcard(object):

    """Implementation of the 'postcard' model.

    TODO: type model description here.

    Attributes:
        description (str): An internal description that identifies this
            resource. Must be no longer than 255 characters.
        metadata (Dict[str, str]): Use metadata to store custom information
            for tagging and labeling back to your internal systems. Must be an
            object with up to 20 key-value pairs. Keys must be at most 40
            characters and values must be at most 500 characters. Neither can
            contain the characters `"` and `\`. i.e. '{"customer_id" :
            "NEWYORK2015"}' Nested objects are not supported.  See
            [Metadata](#section/Metadata) for more information.
        mail_type (MailTypeEnum): TODO: type description here.
        merge_variables (object): You can input a merge variable payload
            object to your template to render dynamic content. For example, if
            you have a template like: `{{variable_name}}`, pass in
            `{"variable_name": "Harry"}` to render `Harry`. `merge_variables`
            must be an object. Any type of value is accepted as long as the
            object is valid JSON; you can use `strings`, `numbers`,
            `booleans`, `arrays`, `objects`, or `null`. The max length of the
            object is 25,000 characters. If you call `JSON.stringify` on your
            object, it can be no longer than 25,000 characters. Your variable
            names cannot contain any whitespace or any of the following
            special characters: `!`, `"`, `#`, `%`, `&`, `'`, `(`, `)`, `*`,
            `+`, `,`, `/`, `;`, `<`, `=`, `>`, `@`, `[`, `\`, `]`, `^`, `` `
            ``, `{`, `|`, `}`, `~`. More instructions can be found in <a
            href="https://help.lob.com/print-and-mail/designing-mail-creatives/
            dynamic-personalization#using-html-and-merge-variables-10"
            target="_blank">our guide to using html and merge variables</a>.
            Depending on your <a
            href="https://dashboard.lob.com/#/settings/account"
            target="_blank">Merge Variable strictness</a> setting, if you
            define variables in your HTML but do not pass them here, you will
            either receive an error or the variable will render as an empty
            string.
        send_date (object): TODO: type description here.
        size (PostcardSizeEnum): TODO: type description here.
        to (object): TODO: type description here.
        carrier (str): TODO: type description here.
        thumbnails (List[Thumbnail]): TODO: type description here.
        expected_delivery_date (date): A date in YYYY-MM-DD format of the
            mailpiece's expected delivery date based on its `send_date`.
        date_created (datetime): A timestamp in ISO 8601 format of the date
            the resource was created.
        date_modified (datetime): A timestamp in ISO 8601 format of the date
            the resource was last modified.
        deleted (bool): Only returned if the resource has been successfully
            deleted.
        mfrom (AddressUs): TODO: type description here.
        id (str): Unique identifier prefixed with `psc_`.
        front_template_id (str): The unique ID of the HTML template used for
            the front of the postcard. Only filled out when the request
            contains a valid postcard template ID.
        back_template_id (str): The unique ID of the HTML template used for
            the back of the postcard. Only filled out when the request
            contains a valid postcard template ID.
        front_template_version_id (str): The unique ID of the specific version
            of the HTML template used for the front of the postcard. Only
            filled out when the request contains a valid postcard template
            ID.
        back_template_version_id (str): The unique ID of the specific version
            of the HTML template used for the back of the postcard. Only
            filled out when the request contains a valid postcard template
            ID.
        tracking_events (List[TrackingEventNormal]): An array of
            tracking_event objects ordered by ascending `time`. Will not be
            populated for postcards created in test mode.
        url (str): A [signed link](#section/Asset-URLs) served over HTTPS. The
            link returned will expire in 30 days to prevent mis-sharing. Each
            time a GET request is initiated, a new signed URL will be
            generated.
        campaign_id (str): The unique ID of the associated campaign if the
            resource was generated from a campaign.
        use_type (object): TODO: type description here.
        status (ThestatusofthebuckslipEnum): TODO: type description here.
        failure_reason (str): A string describing the reason for failure if
            the postcard failed to render.
        object (Object10Enum): TODO: type description here.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "to": 'to',
        "carrier": 'carrier',
        "id": 'id',
        "front_template_id": 'front_template_id',
        "back_template_id": 'back_template_id',
        "url": 'url',
        "description": 'description',
        "metadata": 'metadata',
        "mail_type": 'mail_type',
        "merge_variables": 'merge_variables',
        "send_date": 'send_date',
        "size": 'size',
        "thumbnails": 'thumbnails',
        "expected_delivery_date": 'expected_delivery_date',
        "date_created": 'date_created',
        "date_modified": 'date_modified',
        "deleted": 'deleted',
        "mfrom": 'from',
        "front_template_version_id": 'front_template_version_id',
        "back_template_version_id": 'back_template_version_id',
        "tracking_events": 'tracking_events',
        "campaign_id": 'campaign_id',
        "use_type": 'use_type',
        "status": 'status',
        "failure_reason": 'failure_reason',
        "object": 'object'
    }

    _optionals = [
        'description',
        'metadata',
        'mail_type',
        'merge_variables',
        'send_date',
        'size',
        'thumbnails',
        'expected_delivery_date',
        'date_created',
        'date_modified',
        'deleted',
        'mfrom',
        'front_template_version_id',
        'back_template_version_id',
        'tracking_events',
        'campaign_id',
        'use_type',
        'status',
        'failure_reason',
        'object',
    ]

    _nullables = [
        'description',
        'merge_variables',
        'front_template_id',
        'back_template_id',
        'front_template_version_id',
        'back_template_version_id',
        'tracking_events',
        'campaign_id',
        'failure_reason',
    ]

    def __init__(self,
                 to=None,
                 id=None,
                 front_template_id=None,
                 back_template_id=None,
                 url=None,
                 description=APIHelper.SKIP,
                 metadata=APIHelper.SKIP,
                 mail_type=APIHelper.SKIP,
                 merge_variables=APIHelper.SKIP,
                 send_date=APIHelper.SKIP,
                 size=APIHelper.SKIP,
                 thumbnails=APIHelper.SKIP,
                 expected_delivery_date=APIHelper.SKIP,
                 date_created=APIHelper.SKIP,
                 date_modified=APIHelper.SKIP,
                 deleted=APIHelper.SKIP,
                 mfrom=APIHelper.SKIP,
                 front_template_version_id=APIHelper.SKIP,
                 back_template_version_id=APIHelper.SKIP,
                 tracking_events=APIHelper.SKIP,
                 campaign_id=APIHelper.SKIP,
                 use_type=APIHelper.SKIP,
                 status=APIHelper.SKIP,
                 failure_reason=APIHelper.SKIP,
                 object=APIHelper.SKIP):
        """Constructor for the Postcard class"""

        # Initialize members of the class
        if description is not APIHelper.SKIP:
            self.description = description 
        if metadata is not APIHelper.SKIP:
            self.metadata = metadata 
        if mail_type is not APIHelper.SKIP:
            self.mail_type = mail_type 
        if merge_variables is not APIHelper.SKIP:
            self.merge_variables = merge_variables 
        if send_date is not APIHelper.SKIP:
            self.send_date = send_date 
        if size is not APIHelper.SKIP:
            self.size = size 
        self.to = to 
        self.carrier = 'USPS' 
        if thumbnails is not APIHelper.SKIP:
            self.thumbnails = thumbnails 
        if expected_delivery_date is not APIHelper.SKIP:
            self.expected_delivery_date = expected_delivery_date 
        if date_created is not APIHelper.SKIP:
            self.date_created = APIHelper.apply_datetime_converter(date_created, APIHelper.RFC3339DateTime) if date_created else None 
        if date_modified is not APIHelper.SKIP:
            self.date_modified = APIHelper.apply_datetime_converter(date_modified, APIHelper.RFC3339DateTime) if date_modified else None 
        if deleted is not APIHelper.SKIP:
            self.deleted = deleted 
        if mfrom is not APIHelper.SKIP:
            self.mfrom = mfrom 
        self.id = id 
        self.front_template_id = front_template_id 
        self.back_template_id = back_template_id 
        if front_template_version_id is not APIHelper.SKIP:
            self.front_template_version_id = front_template_version_id 
        if back_template_version_id is not APIHelper.SKIP:
            self.back_template_version_id = back_template_version_id 
        if tracking_events is not APIHelper.SKIP:
            self.tracking_events = tracking_events 
        self.url = url 
        if campaign_id is not APIHelper.SKIP:
            self.campaign_id = campaign_id 
        if use_type is not APIHelper.SKIP:
            self.use_type = use_type 
        if status is not APIHelper.SKIP:
            self.status = status 
        if failure_reason is not APIHelper.SKIP:
            self.failure_reason = failure_reason 
        if object is not APIHelper.SKIP:
            self.object = object 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        to = dictionary.get("to") if dictionary.get("to") else None
        id = dictionary.get("id") if dictionary.get("id") else None
        front_template_id = dictionary.get("front_template_id") if dictionary.get("front_template_id") else None
        back_template_id = dictionary.get("back_template_id") if dictionary.get("back_template_id") else None
        url = dictionary.get("url") if dictionary.get("url") else None
        description = dictionary.get("description") if "description" in dictionary.keys() else APIHelper.SKIP
        metadata = dictionary.get("metadata") if dictionary.get("metadata") else APIHelper.SKIP
        mail_type = dictionary.get("mail_type") if dictionary.get("mail_type") else APIHelper.SKIP
        merge_variables = dictionary.get("merge_variables") if "merge_variables" in dictionary.keys() else APIHelper.SKIP
        send_date = dictionary.get("send_date") if dictionary.get("send_date") else APIHelper.SKIP
        size = dictionary.get("size") if dictionary.get("size") else APIHelper.SKIP
        thumbnails = None
        if dictionary.get('thumbnails') is not None:
            thumbnails = [Thumbnail.from_dictionary(x) for x in dictionary.get('thumbnails')]
        else:
            thumbnails = APIHelper.SKIP
        expected_delivery_date = dateutil.parser.parse(dictionary.get('expected_delivery_date')).date() if dictionary.get('expected_delivery_date') else APIHelper.SKIP
        date_created = APIHelper.RFC3339DateTime.from_value(dictionary.get("date_created")).datetime if dictionary.get("date_created") else APIHelper.SKIP
        date_modified = APIHelper.RFC3339DateTime.from_value(dictionary.get("date_modified")).datetime if dictionary.get("date_modified") else APIHelper.SKIP
        deleted = dictionary.get("deleted") if "deleted" in dictionary.keys() else APIHelper.SKIP
        mfrom = AddressUs.from_dictionary(dictionary.get('from')) if 'from' in dictionary.keys() else APIHelper.SKIP
        front_template_version_id = dictionary.get("front_template_version_id") if "front_template_version_id" in dictionary.keys() else APIHelper.SKIP
        back_template_version_id = dictionary.get("back_template_version_id") if "back_template_version_id" in dictionary.keys() else APIHelper.SKIP
        if 'tracking_events' in dictionary.keys():
            tracking_events = [TrackingEventNormal.from_dictionary(x) for x in dictionary.get('tracking_events')] if dictionary.get('tracking_events') else None
        else:
            tracking_events = APIHelper.SKIP
        campaign_id = dictionary.get("campaign_id") if "campaign_id" in dictionary.keys() else APIHelper.SKIP
        use_type = dictionary.get("use_type") if dictionary.get("use_type") else APIHelper.SKIP
        status = dictionary.get("status") if dictionary.get("status") else APIHelper.SKIP
        failure_reason = dictionary.get("failure_reason") if "failure_reason" in dictionary.keys() else APIHelper.SKIP
        object = dictionary.get("object") if dictionary.get("object") else APIHelper.SKIP
        # Return an object of this model
        return cls(to,
                   id,
                   front_template_id,
                   back_template_id,
                   url,
                   description,
                   metadata,
                   mail_type,
                   merge_variables,
                   send_date,
                   size,
                   thumbnails,
                   expected_delivery_date,
                   date_created,
                   date_modified,
                   deleted,
                   mfrom,
                   front_template_version_id,
                   back_template_version_id,
                   tracking_events,
                   campaign_id,
                   use_type,
                   status,
                   failure_reason,
                   object)
